clear all; close all;
ntimesteps=100; 
meanprecip=3;
p=random('exp',meanprecip,ntimesteps,1); %thats an easy assumption
% make it more realistic
p(p<0.5)=0;

k=2.4;% nash cascade parameter 1
n=3;
% random samples of parameters
krand=random('Uniform',1,5,1000,1);
nrand=random('uniform',1,10,1000,1);

t=[1:length(p)]; % time steps
%nash cascade
u=(1/k/gamma(n)*(t/k).^(n-1)).*exp(-t/k);
qout=conv(p,u); %model output, true
% add an error to creat a pseudo-observatoin
qpseudo_obs=qout+random('normal',0,mean(qout)/5,size(qout)); % model output with error, pseudo observatoins

% more realistic
qpseudo_obs(qpseudo_obs<0)=0.1;

% find best parameter sets of the model to fit the observation
for i=1:length(krand)
    usim=(1/krand(i)/gamma(nrand(i))*(t/krand(i)).^(nrand(i)-1)).*exp(-t/krand(i));
    qsim=conv(p,usim);
    rmse(i,1)=(sum((qpseudo_obs-qsim).^2))^0.5;
end

% plot all, see certain sensitivity
figure(1)
plot(krand,rmse,'o')
xlabel('k_{rand}')
ylabel('rmse')

figure(2)
plot(nrand,rmse,'o')
xlabel('n_{rand}')
ylabel('rmse')

%plot only some of the best sets
%identify of rmse
sortrmse=sort(rmse);
percentile=20;
threshold=sortrmse(round(length(rmse)/100*percentile));

ind=find(rmse<threshold) %can choose quantile instead of threshold
figure(3)
plot(krand(ind),nrand(ind),'o') % see how strongly correlated
xlabel('k_{rand}')
ylabel('n_{rand}')
legend('all param sets that have rmse<threshold')